/**************************************************************************
 *	Copyright (C) 2004  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _H_F3_FE_MAIN
#define _H_F3_FE_MAIN

#include "xml_cfg.hpp"
//#include "fe-main.hpp"
#include "gl_util.hpp"
#include "png_screen.hpp"
#include "parsers/nmap_p.hpp"
#include "parsers/languard_p.hpp"
//#include "parsers/nessus_p.hpp"


class FeMain
{
public:
	FeMain();
	~FeMain();

public:
	bool init(string file);


public: // Replication of previously main() procedures
	int EventHandler(void);
	int screenShot(void);
	char* openFile(void);
	int LoadGLTextures(void);
	int DrawGLScene(void);
	int InitGL(int Width, int Height);
	void drawFps(bool screenfps);
	void testCheckExt();

private:
    XMLConfig* m_Config;
	ScanParser* m_ScanParser;


private: // State variables / Compat only, needs to be changed.
	bool mouseDown;
	int key_mode;
	int prevX;
	int prevY;
	unsigned int ss_id;	// to increment the screenshot filename
	char title[1024];
	Uint32 lastframe;
	Uint32 thisframe;
	GLuint texture[1];
	int ff;
	int fps;
	SDL_Surface *screen;   // The screen surface

	GLUtil*	m_glUtil;
	ScanDraw* nmapScan;

};

#endif // _H_F3_FE_MAIN
