/**************************************************************************
 *	Copyright (C) 2004  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _H_F3_NODE
#define _H_F3_NODE

#include "fe_util.hpp"
#include "fe_draw.hpp"
#include "host-draw.hpp"

class FeNode: public FeDraw
{
public:
	void draw(GLenum mode = GL_RENDER);
	void drawRoot(string label);	// Draws the root, representation
	void addHost(HostDraw* host);
	float getRadius();

public:	// Construction/Destruction
	FeNode();
	FeNode(string label);
	~FeNode();

private:
	void drawNodeLabel();

private:
	float	m_Radius;
	GLuint	m_texLabel;
	string	m_Label;
	vector<HostDraw*> m_Hosts;
	
};	

#endif // _H_F3_NODE

