/**************************************************************************
 *	Copyright (C) 2004  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _H_F3_NMAP_PARSER
#define _H_F3_NMAP_PARSER

#include "../fe_parser.hpp"


class NmapParser : public FeParser
{

public: // Construction/Destruction

public: // Overrides
	bool isUsable(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument* doc);
	bool Parse();

public: // Utils
	HostDraw* parseHost(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* node);

	/**
	*	Receives the port tag and adds the ports to the given host
	*
	* \return true if the parse is successfuly	false otherwise.
	*/
	void parsePorts(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* node, HostDraw* host);

	PortDraw* parsePort(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* node);
	
	void parseAddress(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* node, HostDraw* host);
	void parseOS(XERCES_CPP_NAMESPACE_QUALIFIER DOMNode* node, HostDraw* host);

};


#endif // _H_F3_NMAP_PARSER
