/**************************************************************************
 *	Copyright (C) 2004  iCapsid.net
 *
 * 	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, 
 *	Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _H_F3_SCAN_DRAW
#define _H_F3_SCAN_DRAW

#include "fe_node.hpp"

class ScanDraw : public FeDraw
{

public: // Construction / Destruction
	ScanDraw();
	virtual ~ScanDraw();
	
public: // Data members
	bool rotateOn;
	bool fpsOn;
	GLfloat	rtri;
	GLfloat rotSpeed;
	GLfloat x_Rot;
	GLfloat y_Rot;
	GLfloat y_Trans;
	GLfloat	z_Trans;

	bool m_Dirty;  // Tests wether or not... we need to redraw the scene

public: // Methods
	void draw(GLenum mode = GL_RENDER);
	void drawScene();
	void generate(void);
	void drawRootNode();
	void addNode(FeNode* node);
//	int	getNodeCount();

private:
	GLuint m_dList;
	vector<FeNode*> m_Nodes;

};

#endif //_H_F3_SCAN_DRAW

